function T = ABCD_karal(f,A_left,A_right)% SRR: Edited 1/23/17

% Based on Karal 1953, Puria PhD thesis

PC = getPhysicalConstants;

d_right = 2*sqrt(A_right/pi); d_left = 2*sqrt(A_left/pi);
if A_right>=A_left % make sure the model is oriented correctly
    d0 = d_left; d1 = d_right;
else d0 = d_right; d1 = d_left;
end

alpha = d0/d1;

L = 16*PC.rho*(1/(3*d1*pi^(3/2)))*((1-alpha)+(1-alpha)^2); % Karal inductor

% NOTE: Swapping direction of the T matrix swaps A and D; A=D for the Karal
% correction
if length(f) ==1 % calculate at a single frequency
    T = [1, 1j*2*pi*f*L; 0, 1];
else % calculate at multiple frequencies
    T(1,1,:) = ones(1,length(f)); %A
    T(1,2,:) = 1j*2*pi*f*L; %B
    T(2,1,:) = zeros(1,length(f)); %C 
    T(2,2,:) = ones(1,length(f)); %D
end

